<?php

namespace HS\Http\Controllers\Admin;

use HS\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class PersonalAccessTokenController extends Controller
{
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'token-name' => ['required'],
        ]);

        return auth()->user()->createToken($request->input('token-name', 'Api Token'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        auth()->user()
            ->tokens()
            ->where('id', $id)
            ->delete();

        return back();
    }
}
